module Roglew
  module GL
    ACCUM_ADJACENT_PAIRS_NV                 ||= 0x90AD
    ADJACENT_PAIRS_NV                       ||= 0x90AE
    AFFINE_2D_NV                            ||= 0x9092
    AFFINE_3D_NV                            ||= 0x9094
    ARC_TO_NV                               ||= 0xFE
    BEVEL_NV                                ||= 0x90A6
    BOLD_BIT_NV                             ||= 0x01
    BOUNDING_BOX_NV                         ||= 0x908D
    BOUNDING_BOX_OF_BOUNDING_BOXES_NV       ||= 0x909C
    CIRCULAR_CCW_ARC_TO_NV                  ||= 0xF8
    CIRCULAR_CW_ARC_TO_NV                   ||= 0xFA
    CIRCULAR_TANGENT_ARC_TO_NV              ||= 0xFC
    CLOSE_PATH_NV                           ||= 0x00
    CONVEX_HULL_NV                          ||= 0x908B
    COUNT_DOWN_NV                           ||= 0x9089
    COUNT_UP_NV                             ||= 0x9088
    CUBIC_CURVE_TO_NV                       ||= 0x0C
    DUP_FIRST_CUBIC_CURVE_TO_NV             ||= 0xF2
    DUP_LAST_CUBIC_CURVE_TO_NV              ||= 0xF4
    FILE_NAME_NV                            ||= 0x9074
    FIRST_TO_REST_NV                        ||= 0x90AF
    FONT_ASCENDER_BIT_NV                    ||= 0x00200000
    FONT_DESCENDER_BIT_NV                   ||= 0x00400000
    FONT_HAS_KERNING_BIT_NV                 ||= 0x10000000
    FONT_HEIGHT_BIT_NV                      ||= 0x00800000
    FONT_MAX_ADVANCE_HEIGHT_BIT_NV          ||= 0x02000000
    FONT_MAX_ADVANCE_WIDTH_BIT_NV           ||= 0x01000000
    FONT_UNDERLINE_POSITION_BIT_NV          ||= 0x04000000
    FONT_UNDERLINE_THICKNESS_BIT_NV         ||= 0x08000000
    FONT_UNITS_PER_EM_BIT_NV                ||= 0x00100000
    FONT_X_MAX_BOUNDS_BIT_NV                ||= 0x00040000
    FONT_X_MIN_BOUNDS_BIT_NV                ||= 0x00010000
    FONT_Y_MAX_BOUNDS_BIT_NV                ||= 0x00080000
    FONT_Y_MIN_BOUNDS_BIT_NV                ||= 0x00020000
    GLYPH_HAS_KERNING_BIT_NV                ||= 0x100
    GLYPH_HEIGHT_BIT_NV                     ||= 0x02
    GLYPH_HORIZONTAL_BEARING_ADVANCE_BIT_NV ||= 0x10
    GLYPH_HORIZONTAL_BEARING_X_BIT_NV       ||= 0x04
    GLYPH_HORIZONTAL_BEARING_Y_BIT_NV       ||= 0x08
    GLYPH_VERTICAL_BEARING_ADVANCE_BIT_NV   ||= 0x80
    GLYPH_VERTICAL_BEARING_X_BIT_NV         ||= 0x20
    GLYPH_VERTICAL_BEARING_Y_BIT_NV         ||= 0x40
    GLYPH_WIDTH_BIT_NV                      ||= 0x01
    HORIZONTAL_LINE_TO_NV                   ||= 0x06
    ITALIC_BIT_NV                           ||= 0x02
    LARGE_CCW_ARC_TO_NV                     ||= 0x16
    LARGE_CW_ARC_TO_NV                      ||= 0x18
    LINE_TO_NV                              ||= 0x04
    MITER_REVERT_NV                         ||= 0x90A7
    MITER_TRUNCATE_NV                       ||= 0x90A8
    MOVE_TO_CONTINUES_NV                    ||= 0x90B6
    MOVE_TO_NV                              ||= 0x02
    MOVE_TO_RESETS_NV                       ||= 0x90B5
    PATH_CLIENT_LENGTH_NV                   ||= 0x907F
    PATH_COMMAND_COUNT_NV                   ||= 0x909D
    PATH_COMPUTED_LENGTH_NV                 ||= 0x90A0
    PATH_COORD_COUNT_NV                     ||= 0x909E
    PATH_COVER_DEPTH_FUNC_NV                ||= 0x90BF
    PATH_DASH_ARRAY_COUNT_NV                ||= 0x909F
    PATH_DASH_CAPS_NV                       ||= 0x907B
    PATH_DASH_OFFSET_NV                     ||= 0x907E
    PATH_DASH_OFFSET_RESET_NV               ||= 0x90B4
    PATH_END_CAPS_NV                        ||= 0x9076
    PATH_ERROR_POSITION_NV                  ||= 0x90AB
    PATH_FILL_BOUNDING_BOX_NV               ||= 0x90A1
    PATH_FILL_COVER_MODE_NV                 ||= 0x9082
    PATH_FILL_MASK_NV                       ||= 0x9081
    PATH_FILL_MODE_NV                       ||= 0x9080
    PATH_FOG_GEN_MODE_NV                    ||= 0x90AC
    PATH_FORMAT_PS_NV                       ||= 0x9071
    PATH_FORMAT_SVG_NV                      ||= 0x9070
    PATH_GEN_COEFF_NV                       ||= 0x90B1
    PATH_GEN_COLOR_FORMAT_NV                ||= 0x90B2
    PATH_GEN_COMPONENTS_NV                  ||= 0x90B3
    PATH_GEN_MODE_NV                        ||= 0x90B0
    PATH_INITIAL_DASH_CAP_NV                ||= 0x907C
    PATH_INITIAL_END_CAP_NV                 ||= 0x9077
    PATH_JOIN_STYLE_NV                      ||= 0x9079
    PATH_MITER_LIMIT_NV                     ||= 0x907A
    PATH_OBJECT_BOUNDING_BOX_NV             ||= 0x908A
    PATH_STENCIL_DEPTH_OFFSET_FACTOR_NV     ||= 0x90BD
    PATH_STENCIL_DEPTH_OFFSET_UNITS_NV      ||= 0x90BE
    PATH_STENCIL_FUNC_NV                    ||= 0x90B7
    PATH_STENCIL_REF_NV                     ||= 0x90B8
    PATH_STENCIL_VALUE_MASK_NV              ||= 0x90B9
    PATH_STROKE_BOUNDING_BOX_NV             ||= 0x90A2
    PATH_STROKE_COVER_MODE_NV               ||= 0x9083
    PATH_STROKE_MASK_NV                     ||= 0x9084
    PATH_STROKE_WIDTH_NV                    ||= 0x9075
    PATH_TERMINAL_DASH_CAP_NV               ||= 0x907D
    PATH_TERMINAL_END_CAP_NV                ||= 0x9078
    PRIMARY_COLOR                           ||= 0x8577
    PRIMARY_COLOR_NV                        ||= 0x852C
    QUADRATIC_CURVE_TO_NV                   ||= 0x0A
    RECT_NV                                 ||= 0xF6
    RELATIVE_ARC_TO_NV                      ||= 0xFF
    RELATIVE_CUBIC_CURVE_TO_NV              ||= 0x0D
    RELATIVE_HORIZONTAL_LINE_TO_NV          ||= 0x07
    RELATIVE_LARGE_CCW_ARC_TO_NV            ||= 0x17
    RELATIVE_LARGE_CW_ARC_TO_NV             ||= 0x19
    RELATIVE_LINE_TO_NV                     ||= 0x05
    RELATIVE_MOVE_TO_NV                     ||= 0x03
    RELATIVE_QUADRATIC_CURVE_TO_NV          ||= 0x0B
    RELATIVE_SMALL_CCW_ARC_TO_NV            ||= 0x13
    RELATIVE_SMALL_CW_ARC_TO_NV             ||= 0x15
    RELATIVE_SMOOTH_CUBIC_CURVE_TO_NV       ||= 0x11
    RELATIVE_SMOOTH_QUADRATIC_CURVE_TO_NV   ||= 0x0F
    RELATIVE_VERTICAL_LINE_TO_NV            ||= 0x09
    RESTART_PATH_NV                         ||= 0xF0
    ROUND_NV                                ||= 0x90A4
    SECONDARY_COLOR_NV                      ||= 0x852D
    SKIP_MISSING_GLYPH_NV                   ||= 0x90A9
    SMALL_CCW_ARC_TO_NV                     ||= 0x12
    SMALL_CW_ARC_TO_NV                      ||= 0x14
    SMOOTH_CUBIC_CURVE_TO_NV                ||= 0x10
    SMOOTH_QUADRATIC_CURVE_TO_NV            ||= 0x0E
    SQUARE_NV                               ||= 0x90A3
    STANDARD_FONT_NAME_NV                   ||= 0x9072
    SYSTEM_FONT_NAME_NV                     ||= 0x9073
    TRANSLATE_2D_NV                         ||= 0x9090
    TRANSLATE_3D_NV                         ||= 0x9091
    TRANSLATE_X_NV                          ||= 0x908E
    TRANSLATE_Y_NV                          ||= 0x908F
    TRANSPOSE_AFFINE_2D_NV                  ||= 0x9096
    TRANSPOSE_AFFINE_3D_NV                  ||= 0x9098
    TRIANGULAR_NV                           ||= 0x90A5
    USE_MISSING_GLYPH_NV                    ||= 0x90AA
    UTF16_NV                                ||= 0x909B
    UTF8_NV                                 ||= 0x909A
    VERTICAL_LINE_TO_NV                     ||= 0x08
  end
end

module GL_NV_path_rendering
  module RenderHandle
    include Roglew::RenderHandleExtension

    functions [
        [:glCopyPathNV, [ :uint, :uint ], :void],
        [:glCoverFillPathInstancedNV, [ :int, :uint, :pointer, :uint, :uint, :uint, :pointer ], :void],
        [:glCoverFillPathNV, [ :uint, :uint ], :void],
        [:glCoverStrokePathInstancedNV, [ :int, :uint, :pointer, :uint, :uint, :uint, :pointer ], :void],
        [:glCoverStrokePathNV, [ :uint, :uint ], :void],
        [:glDeletePathsNV, [ :uint, :int ], :void],
        [:glGenPathsNV, [ :int ], :uint],
        [:glGetPathColorGenfvNV, [ :uint, :uint, :pointer ], :void],
        [:glGetPathColorGenivNV, [ :uint, :uint, :pointer ], :void],
        [:glGetPathCommandsNV, [ :uint, :pointer ], :void],
        [:glGetPathCoordsNV, [ :uint, :pointer ], :void],
        [:glGetPathDashArrayNV, [ :uint, :pointer ], :void],
        [:glGetPathLengthNV, [ :uint, :int, :int ], :float],
        [:glGetPathMetricRangeNV, [ :uint, :uint, :int, :int, :pointer ], :void],
        [:glGetPathMetricsNV, [ :uint, :int, :uint, :pointer, :uint, :int, :pointer ], :void],
        [:glGetPathParameterfvNV, [ :uint, :uint, :pointer ], :void],
        [:glGetPathParameterivNV, [ :uint, :uint, :pointer ], :void],
        [:glGetPathSpacingNV, [ :uint, :int, :uint, :pointer, :uint, :float, :float, :uint, :pointer ], :void],
        [:glGetPathTexGenfvNV, [ :uint, :uint, :pointer ], :void],
        [:glGetPathTexGenivNV, [ :uint, :uint, :pointer ], :void],
        [:glInterpolatePathsNV, [ :uint, :uint, :uint, :float ], :void],
        [:glIsPathNV, [ :uint ], :uchar],
        [:glIsPointInFillPathNV, [ :uint, :uint, :float, :float ], :uchar],
        [:glIsPointInStrokePathNV, [ :uint, :float, :float ], :uchar],
        [:glPathColorGenNV, [ :uint, :uint, :uint, :pointer ], :void],
        [:glPathCommandsNV, [ :uint, :int, :pointer, :int, :uint, :pointer ], :void],
        [:glPathCoordsNV, [ :uint, :int, :uint, :pointer ], :void],
        [:glPathCoverDepthFuncNV, [ :uint ], :void],
        [:glPathDashArrayNV, [ :uint, :int, :pointer ], :void],
        [:glPathFogGenNV, [ :uint ], :void],
        [:glPathGlyphRangeNV, [ :uint, :uint, :pointer, :uint, :uint, :int, :uint, :uint, :float ], :void],
        [:glPathGlyphsNV, [ :uint, :uint, :pointer, :uint, :int, :uint, :pointer, :uint, :uint, :float ], :void],
        [:glPathParameterfNV, [ :uint, :uint, :float ], :void],
        [:glPathParameterfvNV, [ :uint, :uint, :pointer ], :void],
        [:glPathParameteriNV, [ :uint, :uint, :int ], :void],
        [:glPathParameterivNV, [ :uint, :uint, :pointer ], :void],
        [:glPathStencilDepthOffsetNV, [ :float, :float ], :void],
        [:glPathStencilFuncNV, [ :uint, :int, :uint ], :void],
        [:glPathStringNV, [ :uint, :uint, :int, :pointer ], :void],
        [:glPathSubCommandsNV, [ :uint, :int, :int, :int, :pointer, :int, :uint, :pointer ], :void],
        [:glPathSubCoordsNV, [ :uint, :int, :int, :uint, :pointer ], :void],
        [:glPathTexGenNV, [ :uint, :uint, :int, :pointer ], :void],
        [:glPointAlongPathNV, [ :uint, :int, :int, :float, :pointer, :pointer, :pointer, :pointer ], :uchar],
        [:glStencilFillPathInstancedNV, [ :int, :uint, :pointer, :uint, :uint, :uint, :uint, :pointer ], :void],
        [:glStencilFillPathNV, [ :uint, :uint, :uint ], :void],
        [:glStencilStrokePathInstancedNV, [ :int, :uint, :pointer, :uint, :int, :uint, :uint, :pointer ], :void],
        [:glStencilStrokePathNV, [ :uint, :int, :uint ], :void],
        [:glTransformPathNV, [ :uint, :uint, :uint, :pointer ], :void],
        [:glWeightPathsNV, [ :uint, :int, :uint, :float ], :void]
    ]
  end
end

