module Roglew
  module GL
    BUFFER_ACCESS_FLAGS               ||= 0x911F
    BUFFER_MAP_LENGTH                 ||= 0x9120
    BUFFER_MAP_OFFSET                 ||= 0x9121
    INT_SAMPLER_2D_RECT               ||= 0x8DCD
    INT_SAMPLER_BUFFER                ||= 0x8DD0
    MAX_RECTANGLE_TEXTURE_SIZE        ||= 0x84F8
    MAX_TEXTURE_BUFFER_SIZE           ||= 0x8C2B
    PRIMITIVE_RESTART                 ||= 0x8F9D
    PRIMITIVE_RESTART_INDEX           ||= 0x8F9E
    PROXY_TEXTURE_RECTANGLE           ||= 0x84F7
    R16_SNORM                         ||= 0x8F98
    R8_SNORM                          ||= 0x8F94
    RED_SNORM                         ||= 0x8F90
    RG_SNORM                          ||= 0x8F91
    RG16_SNORM                        ||= 0x8F99
    RG8_SNORM                         ||= 0x8F95
    RGB_SNORM                         ||= 0x8F92
    RGB16_SNORM                       ||= 0x8F9A
    RGB8_SNORM                        ||= 0x8F96
    RGBA_SNORM                        ||= 0x8F93
    RGBA16_SNORM                      ||= 0x8F9B
    RGBA8_SNORM                       ||= 0x8F97
    SAMPLER_2D_RECT                   ||= 0x8B63
    SAMPLER_2D_RECT_SHADOW            ||= 0x8B64
    SAMPLER_BUFFER                    ||= 0x8DC2
    SIGNED_NORMALIZED                 ||= 0x8F9C
    TEXTURE_BINDING_BUFFER            ||= 0x8C2C
    TEXTURE_BINDING_RECTANGLE         ||= 0x84F6
    TEXTURE_BUFFER                    ||= 0x8C2A
    TEXTURE_BUFFER_DATA_STORE_BINDING ||= 0x8C2D
    TEXTURE_BUFFER_FORMAT             ||= 0x8C2E
    TEXTURE_RECTANGLE                 ||= 0x84F5
    UNSIGNED_INT_SAMPLER_2D_RECT      ||= 0x8DD5
    UNSIGNED_INT_SAMPLER_BUFFER       ||= 0x8DD8
  end
end

module GL_VERSION_3_1
  module RenderHandle
    include Roglew::RenderHandleExtension

    functions [
        [ :glDrawArraysInstanced, [ :uint, :int, :int, :int ], :void],
        [ :glDrawElementsInstanced, [ :uint, :int, :uint, :pointer, :int ], :void],
        [ :glPrimitiveRestartIndex, [ :uint ], :void],
        [ :glTexBuffer, [ :uint, :uint, :uint ], :void]
    ]
  end
end

#GL_VERSION_3_1 implicitly requires:
#  GL_ARB_uniform_buffer_object
#  GL_ARB_copy_buffer